function [ntk,sd] = gramNTK(x1,x2,paramntk)
[n1,m] = size(x1);
[n2,m] = size(x2);
L = paramntk.L;
sigmaw = paramntk.sigmaw;
sigmab = paramntk.sigmab;
flag = paramntk.nonlinearity;
s = (sigmaw^2/m)*(x1*x2') + sigmab^2;
sx1 = (sigmaw^2/m)*sum(x1.*x1,2) + sigmab^2;
sx2 = (sigmaw^2/m)*sum(x2.*x2,2) + sigmab^2;
ntk = s;
for i = 1:L
    sd = gramactcor(s,sx1,sx2,flag,2);
    sd = sd*(sigmaw^2);
    s = gramactcor(s,sx1,sx2,flag,1);
    s = (sigmaw^2)*s + sigmab^2;
   sx1 = (sigmaw^2)*gramactvar(sx1,flag) + sigmab^2; 
   sx2 = (sigmaw^2)*gramactvar(sx2,flag) + sigmab^2;
   ntk = ntk.*sd + s;
end
ntk = ntk - sigmab^2;
end

