function [ntk,sd,sf] = newgramRNTK(x1,x2,param)
[n1,T,m] = size(x1);
[n2,~,~] = size(x2);
L = param.L;
sigmaw = param.sigmaw;
sigmau = param.sigmau;
sigmav = param.sigmav;
sp = zeros(n1,n2,L);
spd = zeros(n1,n2,L);
sx1 = zeros(n1,n2,L);
sx2 = zeros(n1,n2,L);
s = zeros(n1,n2,L);
sd = zeros(n1,n2,L);
yp = zeros(n1,n2,L);
y = zeros(n1,n2,L);

[s,sd,sx1,sx2,sf] = GP_kernel_leyer(squeeze(x1(:,1,:)),squeeze(x2(:,1,:)),sp,sx1,sx2,1,T,param);
y(:,:,1) = s(:,:,1);
if L > 1
   for l = 2:L
       y(:,:,l) = sigmau(l)^2*y(:,:,l-1).*sd(:,:,l-1) + s(:,:,l);
   end
end
yp = y;
sp = s;
spd = sd;
if T > 1
    for t = 2:T
        [s,sd,sx1,sx2,sf] = GP_kernel_leyer(squeeze(x1(:,t,:)),squeeze(x2(:,t,:)),sp,sx1,sx2,t,T,param);
        y(:,:,1) = (sigmaw(1)^2)*yp(:,:,1).*spd(:,:,1) + s(:,:,1);
        if L > 1
           for l = 2:L
               y(:,:,l) =  sigmaw(l)^2*yp(:,:,l).*spd(:,:,l) +  sigmau(l)^2*y(:,:,l-1).*sd(:,:,l-1) + s(:,:,l);
           end
        end
        yp = y;
        sp = s;
        spd = sd;
    end
end
ntk = sigmav^2*yp(:,:,L).*sd(:,:,L) + sf;
end


